grk::CodeStreamDecompress Class Reference

`#include <CodeStreamDecompress.h>`

Inheritance diagram for grk::CodeStreamDecompress:

## Public Member Functions

| CodeStreamDecompress (BufferedStream *stream)
virtual | ~CodeStreamDecompress ()
TileProcessor * | allocateProcessor (uint16_t tileIndex)
DecompressorState * | getDecompressorState (void)
TileCodingParams * | get_current_decode_tcp (void)
bool | isDecodingTilePartHeader ()
bool | readHeader (grk_header_info *header_info)
GrkImage * | getImage (uint16_t tileIndex)
GrkImage * | getImage (void)
std::vector< GrkImage * > | getAllImages (void)
void | init (grk_decompress_core_params *p_param)
bool | setDecompressRegion (grk_rect_single region)
bool | decompress (grk_plugin_tile *tile)
bool | decompressTile (uint16_t tileIndex)
bool | preProcess (void)
bool | postProcess (void)
CodeStreamInfo * | getCodeStreamInfo (void)
GrkImage * | getCompositeImage ()
bool | readMarker (void)
bool | readMarker (bool suppressWarning)
GrkImage * | getHeaderImage (void)
uint16_t | getCurrentMarker (void)
void | dump (uint32_t flag, FILE *outputFileStream)
bool | needsHeaderRead (void)
void | setExpectSOD ()
Public Member Functions inherited from grk::CodeStream
| CodeStream (BufferedStream *stream)
virtual | ~CodeStream ()
TileProcessor * | currentProcessor (void)
BufferedStream * | getStream ()
GrkImage * | getHeaderImage (void)
grk_plugin_tile * | getCurrentPluginTile ()
CodingParams * | getCodingParams (void)
Public Member Functions inherited from grk::ICodeStreamDecompress
virtual | ~ICodeStreamDecompress ()=default

## Protected Member Functions

void | dump_MH_info (FILE *outputFileStream)
void | dump_image_header (GrkImage *image, bool dev_dump_flag, FILE *outputFileStream)
| Dump an image header structure.
void | dump_tile_info (TileCodingParams *default_tile, uint32_t numcomps, FILE *outputFileStream)
void | dump_image_comp_header (grk_image_comp *comp, bool dev_dump_flag, FILE *outputFileStream)
| Dump a component image header structure.
Protected Member Functions inherited from grk::CodeStream
bool | exec (std::vector< PROCEDURE_FUNC > &p_procedure_list)

## Private Member Functions

bool | readCurrentMarkerBody (uint16_t *markerSize)
bool | endOfCodeStream (void)
bool | read_short (uint16_t *val)
bool | process_marker (const marker_handler *marker_handler, uint16_t marker_size)
bool | readSOTorEOC (void)
bool | parseTileParts (bool *can_decode_tile_data)
bool | readHeaderProcedureImpl (void)
bool | decompressExec ()
bool | decompressTile ()
bool | findNextSOT (TileProcessor *tileProcessor)
bool | skipNonScheduledTLM (CodingParams *cp)
bool | hasTLM (void)
void | nextTLM (void)
bool | decompressTiles (void)
bool | decompressValidation (void)
bool | copy_default_tcp (void)
bool | read_unk (void)
void | addMarker (uint16_t id, uint64_t pos, uint32_t len)
| Add main header marker information.
bool | read_mct (uint8_t *headerData, uint16_t header_size)
| Reads a MCT marker (Multiple Component Transform)
bool | read_mcc (uint8_t *headerData, uint16_t header_size)
| Reads a MCC marker (Multiple Component Collection)
bool | read_mco (uint8_t *headerData, uint16_t header_size)
| Reads a MCO marker (Multiple Component Transform Ordering)
bool | add_mct (TileCodingParams *p_tcp, GrkImage *p_image, uint32_t index)
bool | read_cbd (uint8_t *headerData, uint16_t header_size)
| Reads a CBD marker (Component bit depth definition)
bool | read_rgn (uint8_t *headerData, uint16_t header_size)
| Reads a RGN marker (Region Of Interest)
bool | readHeaderProcedure (void)
bool | read_soc ()
| Reads a SOC marker (Start of Codestream)
bool | read_siz (uint8_t *headerData, uint16_t header_size)
| Reads a SIZ marker (image and tile size)
bool | read_cap (uint8_t *headerData, uint16_t header_size)
| Reads a CAP marker.
bool | read_com (uint8_t *headerData, uint16_t header_size)
| Reads a COM marker (comments)
bool | read_cod (uint8_t *headerData, uint16_t header_size)
| Reads a COD marker (Coding Style defaults)
bool | read_poc (uint8_t *headerData, uint16_t header_size)
| Reads a POC marker (Progression Order Change)
bool | read_crg (uint8_t *headerData, uint16_t header_size)
| Reads a CRG marker (Component registration)
bool | read_tlm (uint8_t *headerData, uint16_t header_size)
| Reads a TLM marker (Tile Length Marker)
bool | read_plm (uint8_t *headerData, uint16_t header_size)
| Reads a PLM marker (Packet length, main header marker)
bool | read_plt (uint8_t *headerData, uint16_t header_size)
| Reads a PLT marker (Packet length, tile-part header)
bool | read_ppm (uint8_t *headerData, uint16_t header_size)
| Reads a PPM marker (Packed headers, main header)
bool | read_ppt (uint8_t *headerData, uint16_t header_size)
| Reads a PPT marker (Packed packet headers, tile-part header)
bool | read_sot (uint8_t *headerData, uint16_t header_size)
| Read SOT (Start of tile part) marker.
bool | read_SPCod_SPCoc (uint16_t compno, uint8_t *headerData, uint16_t *header_size)
| Reads a SPCod or SPCoc element, i.e.
bool | read_SQcd_SQcc (bool fromQCC, uint16_t compno, uint8_t *headerData, uint16_t *header_size)
| Reads a SQcd or SQcc element, i.e.
bool | merge_ppm (CodingParams *p_cp)
| Merges all PPM markers read (Packed headers, main header)
bool | merge_ppt (TileCodingParams *p_tcp)
| Merges all PPT markers read (Packed headers, tile-part header)
bool | read_coc (uint8_t *headerData, uint16_t header_size)
| Reads a COC marker (Coding Style Component)
bool | read_qcd (uint8_t *headerData, uint16_t header_size)
| Reads a QCD marker (Quantization defaults)
bool | read_qcc (uint8_t *headerData, uint16_t header_size)
| Reads a QCC marker (Quantization component)
const marker_handler * | get_marker_handler (uint16_t id)
| Reads the lookup table containing all the marker, status and action, and returns the handler associated with the marker value.
bool | createOutputImage (void)
bool | checkForIllegalTilePart (void)

## Private Attributes

std::map< uint16_t, marker_handler * > | marker_map
DecompressorState | decompressorState_
bool | expectSOD_
uint16_t | curr_marker_
bool | headerError_
bool | headerRead_
uint8_t * | marker_scratch_
uint16_t | marker_scratch_size_
GrkImage * | outputImage_
TileCache * | tileCache_
StripCache | stripCache_
grk_io_pixels_callback | ioBufferCallback
void * | ioUserData
grk_io_register_reclaim_callback | grkRegisterReclaimCallback_

## Additional Inherited Members

Static Public Member Functions inherited from grk::CodeStream
static std::string | markerString (uint16_t marker)
Protected Attributes inherited from grk::CodeStream
CodingParams | cp_
CodeStreamInfo * | codeStreamInfo
std::vector< PROCEDURE_FUNC > | procedure_list_
std::vector< PROCEDURE_FUNC > | validation_list_
GrkImage * | headerImage_
TileProcessor * | currentTileProcessor_
BufferedStream * | stream_
std::map< uint32_t, TileProcessor * > | processors_
grk_plugin_tile * | current_plugin_tile

## Constructor & Destructor Documentation

## CodeStreamDecompress()

grk::CodeStreamDecompress::CodeStreamDecompress | ( | BufferedStream * | stream | ) |

References grk::CodeStream::codeStreamInfo, grk::DECOMPRESS_STATE_MH, grk::DECOMPRESS_STATE_MH_SIZ, grk::DECOMPRESS_STATE_TPH, grk::DECOMPRESS_STATE_TPH_SOT, decompressorState_, grk::DecompressorState::default_tcp_, grk_image_meta_new(), grk::grk_read(), grk::CodeStream::headerImage_, grk::J2K_MS_CAP, grk::J2K_MS_CBD, grk::J2K_MS_COC, grk::J2K_MS_COD, grk::J2K_MS_COM, grk::J2K_MS_CRG, grk::J2K_MS_MCC, grk::J2K_MS_MCO, grk::J2K_MS_MCT, grk::J2K_MS_PLM, grk::J2K_MS_PLT, grk::J2K_MS_POC, grk::J2K_MS_PPM, grk::J2K_MS_PPT, grk::J2K_MS_QCC, grk::J2K_MS_QCD, grk::J2K_MS_RGN, grk::J2K_MS_SIZ, grk::J2K_MS_SOT, grk::J2K_MS_TLM, grk::DecompressorState::lastSotReadPosition, marker_map, _grk_image::meta, read_cap(), read_cbd(), read_coc(), read_cod(), read_com(), read_crg(), read_mcc(), read_mco(), read_mct(), read_plm(), read_plt(), read_poc(), read_ppm(), read_ppt(), read_qcc(), read_qcd(), read_rgn(), read_siz(), read_sot(), and read_tlm().

## ~CodeStreamDecompress()

grk::CodeStreamDecompress::~CodeStreamDecompress | ( |  | ) |

virtual

References decompressorState_, grk::DecompressorState::default_tcp_, grk_object_unref(), marker_map, marker_scratch_, _grk_image::obj, outputImage_, and tileCache_.

## Member Function Documentation

## add_mct()

bool grk::CodeStreamDecompress::add_mct | ( | TileCodingParams * | p_tcp,
|  | GrkImage * | p_image,
|  | uint32_t | index
| ) |  |

private

element discarded

do not support number of comps != image

References grk::grk_free(), grk::grk_malloc(), grk::grk_read(), grk::j2k_mct_read_functions_to_float, grk::j2k_mct_read_functions_to_int32, and grk::MCT_ELEMENT_SIZE.

Referenced by read_mco().

## addMarker()

void grk::CodeStreamDecompress::addMarker | ( | uint16_t | id,
|  | uint64_t | pos,
|  | uint32_t | len
| ) |  |

private

Add main header marker information.

Parameters

  id | marker id
  pos | byte offset of marker segment
  len | length of marker segment

References grk::CodeStream::codeStreamInfo, and grk::CodeStreamInfo::pushMarker().

Referenced by read_soc(), read_unk(), and readHeaderProcedureImpl().

## allocateProcessor()

TileProcessor * grk::CodeStreamDecompress::allocateProcessor | ( | uint16_t | tileIndex | ) |

References grk::CodeStream::currentTileProcessor_, grk::TileCache::get(), grk::grk_read(), grk::TileCacheEntry::processor, grk::TileCache::put(), grk::CodeStream::stream_, stripCache_, and tileCache_.

Referenced by grk::SOTMarker::read().

## checkForIllegalTilePart()

bool grk::CodeStreamDecompress::checkForIllegalTilePart | ( | void |  | ) |

private

References grk::grk_read(), and readCurrentMarkerBody().

Referenced by decompressTile(), and decompressTiles().

## copy_default_tcp()

bool grk::CodeStreamDecompress::copy_default_tcp | ( | void |  | ) |

private

References grk::CodeStream::cp_, decompressorState_, grk::DecompressorState::default_tcp_, grk::grk_read(), grk::CodeStream::headerImage_, grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, and grk::CodingParams::tcps.

Referenced by readHeader().

## createOutputImage()

bool grk::CodeStreamDecompress::createOutputImage | ( | void |  | ) |

private

References grk::GrkImage::allocCompositeData(), grk::GrkImage::copyHeader(), grk::CodeStream::cp_, getCompositeImage(), grk_object_unref(), _grk_image::hasMultipleTiles, grk::CodeStream::headerImage_, _grk_image::obj, outputImage_, and grk::GrkImage::supportsStripCache().

Referenced by decompressTile(), and decompressTiles().

## decompress()

bool grk::CodeStreamDecompress::decompress | ( | grk_plugin_tile * | tile | ) |

virtual

Implements grk::ICodeStreamDecompress.

References grk::CodeStream::current_plugin_tile, decompressExec(), decompressTiles(), and grk::CodeStream::procedure_list_.

Referenced by grk::FileFormatDecompress::decompress().

## decompressExec()

bool grk::CodeStreamDecompress::decompressExec | ( | void |  | ) |

private

References grk::CodeStream::exec(), getCompositeImage(), outputImage_, grk::CodeStream::procedure_list_, and grk::GrkImage::transferDataTo().

Referenced by decompress(), and decompressTile().

## decompressTile() [1/2]

bool grk::CodeStreamDecompress::decompressTile | ( | void |  | ) |

private

References grk::CodeStreamInfo::allocTileInfo(), checkForIllegalTilePart(), grk::CodeStream::codeStreamInfo, grk::CodingParams::coding_params_, grk::CodeStream::cp_, createOutputImage(), curr_marker_, grk::CodeStream::currentTileProcessor_, grk::CodingParams::dec_, grk::DECOMPRESS_STATE_EOC, grk::DECOMPRESS_STATE_TPH_SOT, decompressorState_, ExecSingleton::get(), grk::TileCache::get(), grk::TileSet::getSingle(), grk::DecompressorState::getState(), grk::GRK_ERROR(), grk::grk_read(), grkRegisterReclaimCallback_, _grk_image::hasMultipleTiles, grk::GrkImage::height(), grk::StripCache::init(), ioBufferCallback, ioUserData, grk::J2K_MS_SOT, grk::TileSet::numScheduled(), outputImage_, parseTileParts(), grk::TileCacheEntry::processor, readSOTorEOC(), grk::DecodingParams::reduce_, _grk_image::rowsPerStrip, grk::CodeStreamInfo::seekFirstTilePart(), grk::DecompressorState::setState(), skipNonScheduledTLM(), stripCache_, grk::GrkImage::supportsStripCache(), grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, tileCache_, and grk::DecompressorState::tilesToDecompress_.

Referenced by decompressTile().

## decompressTile() [2/2]

bool grk::CodeStreamDecompress::decompressTile | ( | uint16_t | tileIndex | ) |

virtual

Implements grk::ICodeStreamDecompress.

References grk::CodeStreamInfo::allocTileInfo(), grk::CodeStream::codeStreamInfo, grk::CodingParams::coding_params_, grk::GrkImage::copyHeader(), grk::CodeStream::cp_, grk::CodingParams::dec_, decompressExec(), decompressorState_, decompressTile(), grk::TileCache::get(), getCompositeImage(), grk::CodingParams::getTileBounds(), grk::GRK_ERROR(), grk::grk_read(), grk::GRK_WARN(), headerError_, grk::CodeStream::headerImage_, grk::grk_rect< T >::intersection(), outputImage_, grk::CodeStream::procedure_list_, grk::DecodingParams::reduce_, grk::TileSet::schedule(), grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, grk::CodingParams::tcps, tileCache_, grk::TileCodingParams::tilePartCounter_, grk::DecompressorState::tilesToDecompress_, and grk::grk_rect< T >::x0.

Referenced by grk::FileFormatDecompress::decompressTile().

## decompressTiles()

bool grk::CodeStreamDecompress::decompressTiles | ( | void |  | ) |

private

References grk::TileSet::allComplete(), grk::CodeStreamInfo::allocTileInfo(), checkForIllegalTilePart(), grk::CodeStream::codeStreamInfo, grk::CodingParams::coding_params_, grk::GrkImage::composite(), grk::CodeStream::cp_, createOutputImage(), curr_marker_, grk::CodeStream::currentTileProcessor_, grk::CodingParams::dec_, decompressorState_, endOfCodeStream(), grk::CodeStream::exec(), findNextSOT(), ExecSingleton::get(), grk::TileCache::getStrategy(), grk::GRK_ERROR(), grk::grk_read(), GRK_TILE_CACHE_NONE, grk::GRK_WARN(), grkRegisterReclaimCallback_, _grk_image::hasMultipleTiles, headerError_, grk::GrkImage::height(), grk::StripCache::ingestTile(), grk::StripCache::init(), ioBufferCallback, ioUserData, grk::J2K_MS_SOT, outputImage_, parseTileParts(), grk::DecodingParams::reduce_, _grk_image::rowsPerStrip, stripCache_, grk::GrkImage::supportsStripCache(), grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, grk::CodingParams::t_height, tileCache_, grk::DecompressorState::tilesToDecompress_, and grk::CodingParams::wholeTileDecompress_.

Referenced by decompress().

## decompressValidation()

bool grk::CodeStreamDecompress::decompressValidation | ( | void |  | ) |

private

References grk::DECOMPRESS_STATE_NONE, decompressorState_, and grk::DecompressorState::getState().

Referenced by readHeader().

## dump()

void grk::CodeStreamDecompress::dump | ( | uint32_t | flag,
|  | FILE * | outputFileStream
| ) |  |

virtual

Implements grk::ICodeStreamDecompress.

References grk::CodeStream::codeStreamInfo, grk::CodeStreamInfo::dump(), dump_image_header(), dump_MH_info(), dump_tile_info(), grk::CodeStream::getCodingParams(), getHeaderImage(), GRK_IMG_INFO, GRK_J2K_MH_IND, GRK_J2K_MH_INFO, GRK_J2K_TCH_INFO, GRK_JP2_IND, GRK_JP2_INFO, and grk::grk_read().

Referenced by grk::FileFormatDecompress::dump().

## dump_image_comp_header()

void grk::CodeStreamDecompress::dump_image_comp_header | ( | grk_image_comp * | comp,
|  | bool | dev_dump_flag,
|  | FILE * | outputFileStream
| ) |  |

protected

Dump a component image header structure.

Parameters

  comp | the component image header to dump.
  dev_dump_flag | flag to describe if we are in the case of this function is use outside dump function
  outputFileStream | output stream where dump the elements.

References grk::grk_read().

Referenced by dump_image_header().

## dump_image_header()

void grk::CodeStreamDecompress::dump_image_header | ( | GrkImage * | image,
|  | bool | dev_dump_flag,
|  | FILE * | outputFileStream
| ) |  |

protected

Dump an image header structure.

Parameters

  image | the image header to dump.
  dev_dump_flag | flag to describe if we are in the case of this function is use outside dump function
  outputFileStream | output stream where dump the elements.

References _grk_image::comps, dump_image_comp_header(), grk::grk_read(), _grk_image::numcomps, _grk_image::x0, _grk_image::x1, _grk_image::y0, and _grk_image::y1.

Referenced by dump().

## dump_MH_info()

void grk::CodeStreamDecompress::dump_MH_info | ( | FILE * | outputFileStream | ) |

protected

References grk::CodeStream::cp_, dump_tile_info(), getDecompressorState(), getHeaderImage(), grk::grk_read(), grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, grk::CodingParams::t_height, grk::CodingParams::t_width, grk::CodingParams::tx0, and grk::CodingParams::ty0.

Referenced by dump().

## dump_tile_info()

void grk::CodeStreamDecompress::dump_tile_info | ( | TileCodingParams * | default_tile,
|  | uint32_t | numcomps,
|  | FILE * | outputFileStream
| ) |  |

protected

References grk::grk_read(), and J2K_CCP_QNTSTY_SIQNT.

Referenced by dump(), and dump_MH_info().

## endOfCodeStream()

bool grk::CodeStreamDecompress::endOfCodeStream | ( | void |  | ) |

private

References grk::DECOMPRESS_STATE_EOC, grk::DECOMPRESS_STATE_NO_EOC, decompressorState_, grk::DecompressorState::getState(), grk::BufferedStream::numBytesLeft(), and grk::CodeStream::stream_.

Referenced by decompressTiles().

## findNextSOT()

bool grk::CodeStreamDecompress::findNextSOT | ( | TileProcessor * | tileProcessor | ) |

private

References grk::CodeStream::cp_, grk::TileProcessor::current_plugin_tile, _grk_plugin_tile::decompress_flags, grk::DECOMPRESS_STATE_DATA, decompressorState_, grk::DecompressorState::findNextSOT(), grk::TileProcessor::getIndex(), grk::DecompressorState::getState(), GRK_DECODE_POST_T1, grk::GRK_ERROR(), grk::grk_read(), and grk::CodingParams::tcps.

Referenced by decompressTiles().

## get_current_decode_tcp()

TileCodingParams * grk::CodeStreamDecompress::get_current_decode_tcp | ( | void |  | ) |

References grk::CodeStream::cp_, grk::CodeStream::currentTileProcessor_, decompressorState_, grk::DecompressorState::default_tcp_, grk::TileProcessor::getIndex(), isDecodingTilePartHeader(), and grk::CodingParams::tcps.

Referenced by grk::TileProcessor::cacheTilePartPackets(), parseTileParts(), read_coc(), read_cod(), read_mcc(), read_mco(), read_mct(), read_poc(), read_qcd(), read_rgn(), read_SPCod_SPCoc(), and read_SQcd_SQcc().

## get_marker_handler()

const marker_handler * grk::CodeStreamDecompress::get_marker_handler | ( | uint16_t | id | ) |

private

Reads the lookup table containing all the marker, status and action, and returns the handler associated with the marker value.

Parameters

  id | Marker value to look up

Returns
  the handler associated with the id.

References grk::grk_read(), grk::GRK_WARN(), and marker_map.

Referenced by read_unk(), readCurrentMarkerBody(), and readHeaderProcedureImpl().

## getAllImages()

std::vector< GrkImage * > grk::CodeStreamDecompress::getAllImages | ( | void |  | ) |

References grk::TileCache::getAllImages(), and tileCache_.

Referenced by postProcess().

## getCodeStreamInfo()

CodeStreamInfo * grk::CodeStreamDecompress::getCodeStreamInfo | ( | void |  | ) |

References grk::CodeStream::codeStreamInfo.

Referenced by grk::TileProcessor::cacheTilePartPackets(), and grk::SOTMarker::read().

## getCompositeImage()

GrkImage * grk::CodeStreamDecompress::getCompositeImage | ( |  | ) |

References grk::TileCache::getComposite(), and tileCache_.

Referenced by createOutputImage(), decompressExec(), decompressTile(), getImage(), postProcess(), grk::FileFormatDecompress::preProcess(), readHeader(), grk::FileFormatDecompress::readHeader(), and setDecompressRegion().

## getCurrentMarker()

uint16_t grk::CodeStreamDecompress::getCurrentMarker | ( | void |  | ) |

References curr_marker_.

Referenced by grk::DecompressorState::findNextSOT().

## getDecompressorState()

DecompressorState * grk::CodeStreamDecompress::getDecompressorState | ( | void |  | ) |

References decompressorState_.

Referenced by grk::TileProcessor::cacheTilePartPackets(), dump_MH_info(), grk::SIZMarker::read(), and grk::SOTMarker::read().

## getHeaderImage()

GrkImage * grk::CodeStreamDecompress::getHeaderImage | ( | void |  | ) |

References grk::CodeStream::headerImage_.

Referenced by dump(), dump_MH_info(), grk::FileFormatDecompress::getColour(), grk::SIZMarker::read(), read_cbd(), read_coc(), read_cod(), read_crg(), read_mco(), grk::FileFormatDecompress::read_palette_clr(), read_poc(), read_qcc(), read_qcd(), read_rgn(), read_SPCod_SPCoc(), and read_SQcd_SQcc().

## getImage() [1/2]

GrkImage * grk::CodeStreamDecompress::getImage | ( | uint16_t | tileIndex | ) |

virtual

Implements grk::ICodeStreamDecompress.

References grk::TileCache::get(), grk::TileProcessor::getImage(), grk::grk_read(), grk::TileCacheEntry::processor, and tileCache_.

Referenced by grk::FileFormatDecompress::getImage(), and grk::FileFormatDecompress::getImage().

## getImage() [2/2]

GrkImage * grk::CodeStreamDecompress::getImage | ( | void |  | ) |

virtual

Implements grk::ICodeStreamDecompress.

References getCompositeImage().

## hasTLM()

bool grk::CodeStreamDecompress::hasTLM | ( | void |  | ) |

private

References grk::CodeStream::cp_, grk::CodingParams::tlm_markers, and grk::TileLengthMarkers::valid().

Referenced by nextTLM(), and skipNonScheduledTLM().

## init()

void grk::CodeStreamDecompress::init | ( | grk_decompress_core_params * | p_param | ) |

virtual

Implements grk::ICodeStreamDecompress.

References grk::CodingParams::coding_params_, grk::CodeStream::cp_, grk::CodingParams::dec_, grk::grk_read(), grkRegisterReclaimCallback_, ioBufferCallback, ioUserData, grk::DecodingParams::layer_, grk::DecodingParams::randomAccessFlags_, grk::DecodingParams::reduce_, grk::TileCache::setStrategy(), and tileCache_.

Referenced by grk::FileFormatDecompress::init().

## isDecodingTilePartHeader()

bool grk::CodeStreamDecompress::isDecodingTilePartHeader | ( |  | ) |

References grk::DECOMPRESS_STATE_TPH, decompressorState_, and grk::DecompressorState::getState().

Referenced by get_current_decode_tcp(), and read_SQcd_SQcc().

## merge_ppm()

bool grk::CodeStreamDecompress::merge_ppm | ( | CodingParams * | p_cp | ) |

private

Merges all PPM markers read (Packed headers, main header)

Parameters

  p_cp | main coding parameters.

References grk::grk_read().

Referenced by readHeaderProcedureImpl().

## merge_ppt()

bool grk::CodeStreamDecompress::merge_ppt | ( | TileCodingParams * | p_tcp | ) |

private

Merges all PPT markers read (Packed headers, tile-part header)

Merges all PPT markers read (Packed packet headers, tile-part header)

Parameters

  p_tcp | the tile.

References grk::GRK_ERROR(), grk::grk_free(), and grk::grk_read().

Referenced by parseTileParts().

## needsHeaderRead()

bool grk::CodeStreamDecompress::needsHeaderRead | ( | void |  | ) |

References headerError_, and headerRead_.

Referenced by grk::FileFormatDecompress::readHeader().

## nextTLM()

void grk::CodeStreamDecompress::nextTLM | ( | void |  | ) |

private

References grk::CodeStream::cp_, grk::CodeStream::currentTileProcessor_, decompressorState_, grk::TileProcessor::getIndex(), grk::grk_read(), grk::GRK_WARN(), hasTLM(), grk::TileLengthMarkers::invalidate(), grk::DecompressorState::lastSotReadPosition, grk::TileLengthMarkers::next(), grk::CodeStream::stream_, grk::BufferedStream::tell(), and grk::CodingParams::tlm_markers.

Referenced by parseTileParts().

## parseTileParts()

bool grk::CodeStreamDecompress::parseTileParts | ( | bool * | can_decode_tile_data | ) |

private

References grk::TileLengthMarkers::addTileMarkerInfo(), grk::TileProcessor::cacheTilePartPackets(), grk::CodeStream::codeStreamInfo, grk::CodeStream::cp_, curr_marker_, grk::CodeStream::currentTileProcessor_, grk::DECOMPRESS_STATE_DATA, grk::DECOMPRESS_STATE_EOC, grk::DECOMPRESS_STATE_NO_EOC, grk::DECOMPRESS_STATE_TPH_SOT, decompressorState_, expectSOD_, get_current_decode_tcp(), grk::TileProcessor::getIndex(), grk::DecompressorState::getState(), grk::TileProcessor::getTilePartDataLength(), grk::GRK_ERROR(), grk::grk_read(), grk::CodeStream::headerImage_, grk::TileProcessor::init(), grk::TileSet::isComplete(), grk::TileSet::isScheduled(), J2K_CCP_QNTSTY_NOQNT, J2K_CCP_QNTSTY_SIQNT, grk::J2K_MS_EOC, grk::J2K_MS_SOD, grk::J2K_MS_SOT, grk::DecompressorState::lastSotReadPosition, grk::MARKER_PLUS_MARKER_LENGTH_BYTES, merge_ppt(), nextTLM(), grk::BufferedStream::numBytesLeft(), _grk_image::numcomps, grk::DecompressorState::orState(), readCurrentMarkerBody(), readMarker(), readSOTorEOC(), grk::DecompressorState::setState(), grk::BufferedStream::skip(), skipNonScheduledTLM(), grk::CodeStream::stream_, grk::CodingParams::tcps, grk::BufferedStream::tell(), and grk::DecompressorState::tilesToDecompress_.

Referenced by decompressTile(), and decompressTiles().

## postProcess()

bool grk::CodeStreamDecompress::postProcess | ( | void |  | ) |

virtual

Implements grk::ICodeStreamDecompress.

References grk::CodeStream::cp_, getAllImages(), getCompositeImage(), grk::grk_read(), and grk::CodingParams::wholeTileDecompress_.

Referenced by grk::FileFormatDecompress::postProcess().

## preProcess()

bool grk::CodeStreamDecompress::preProcess | ( | void |  | ) |

virtual

Implements grk::ICodeStreamDecompress.

## process_marker()

bool grk::CodeStreamDecompress::process_marker | ( | const marker_handler * | marker_handler,
|  | uint16_t | marker_size
| ) |  |

private

References grk::default_header_size, grk::marker_handler::func, grk::GRK_ERROR(), grk::grk_read(), marker_scratch_, marker_scratch_size_, grk::BufferedStream::numBytesLeft(), grk::BufferedStream::read(), and grk::CodeStream::stream_.

Referenced by readCurrentMarkerBody(), and readHeaderProcedureImpl().

## read_cap()

bool grk::CodeStreamDecompress::read_cap | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a CAP marker.

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodingParams::ccap, grk::CodeStream::cp_, grk::GRK_ERROR(), grk_population_count(), grk::grk_read(), and grk::CodingParams::pcap.

Referenced by CodeStreamDecompress().

## read_cbd()

bool grk::CodeStreamDecompress::read_cbd | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a CBD marker (Component bit depth definition)

Parameters

  headerData | header data
  header_size | size of header data

References _grk_image::comps, getHeaderImage(), grk::GRK_ERROR(), grk::grk_read(), _grk_image::numcomps, and _grk_image_comp::sgnd.

Referenced by CodeStreamDecompress().

## read_coc()

bool grk::CodeStreamDecompress::read_coc | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a COC marker (Coding Style Component)

Parameters

  headerData | header data
  header_size | size of header data

References get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), grk::grk_read(), and read_SPCod_SPCoc().

Referenced by CodeStreamDecompress().

## read_cod()

bool grk::CodeStreamDecompress::read_cod | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a COD marker (Coding Style defaults)

Parameters

  headerData | header data
  header_size | size of header data

References grk::cod_coc_len, grk::CodeStream::cp_, get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), GRK_NUM_PROGRESSION_ORDERS, grk::grk_read(), grk::GRK_WARN(), J2K_CCP_CSTY_PRT, J2K_CP_CSTY_EPH, J2K_CP_CSTY_PRT, J2K_CP_CSTY_SOP, _grk_image::numcomps, and read_SPCod_SPCoc().

Referenced by CodeStreamDecompress().

## read_com()

bool grk::CodeStreamDecompress::read_com | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a COM marker (comments)

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodingParams::comment, grk::CodingParams::comment_len, grk::CodeStream::cp_, grk::GRK_ERROR(), GRK_NUM_COMMENTS_SUPPORTED, grk::grk_read(), grk::GRK_WARN(), grk::CodingParams::isBinaryComment, and grk::CodingParams::num_comments.

Referenced by CodeStreamDecompress().

## read_crg()

bool grk::CodeStreamDecompress::read_crg | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a CRG marker (Component registration)

Parameters

  headerData | header data
  header_size | size of header data

References _grk_image::comps, getHeaderImage(), grk::GRK_ERROR(), grk::grk_read(), and _grk_image::numcomps.

Referenced by CodeStreamDecompress().

## read_mcc()

bool grk::CodeStreamDecompress::read_mcc | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a MCC marker (Multiple Component Collection)

Parameters

  headerData | header data
  header_size | size of header data

NOT FOUND

References grk::default_number_mcc_records, get_current_decode_tcp(), grk::GRK_ERROR(), grk::grk_free(), grk::grk_read(), grk::grk_realloc(), and grk::GRK_WARN().

Referenced by CodeStreamDecompress().

## read_mco()

bool grk::CodeStreamDecompress::read_mco | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a MCO marker (Multiple Component Transform Ordering)

Parameters

  headerData | header data.
  header_size | size of header data

References add_mct(), get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), grk::grk_free(), grk::grk_read(), and grk::GRK_WARN().

Referenced by CodeStreamDecompress().

## read_mct()

bool grk::CodeStreamDecompress::read_mct | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a MCT marker (Multiple Component Transform)

Parameters

  headerData | header data
  header_size | size of header data

References grk::grk_simple_mcc_decorrelation_data::decorrelation_array_, grk::default_number_mct_records, get_current_decode_tcp(), grk::GRK_ERROR(), grk::grk_free(), grk::grk_malloc(), grk::grk_read(), grk::grk_realloc(), and grk::GRK_WARN().

Referenced by CodeStreamDecompress().

## read_plm()

bool grk::CodeStreamDecompress::read_plm | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a PLM marker (Packet length, main header marker)

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodeStream::cp_, grk::grk_read(), grk::CodingParams::plm_markers, and grk::PLMarkerMgr::readPLM().

Referenced by CodeStreamDecompress().

## read_plt()

bool grk::CodeStreamDecompress::read_plt | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a PLT marker (Packet length, tile-part header)

Parameters

  headerData | header data
  header_size | size of header data
  headerData | the data contained in the PLT box.
  header_size | the size of the data contained in the PLT marker.

References grk::CodingParams::coding_params_, grk::CodeStream::cp_, grk::CodeStream::currentProcessor(), grk::CodingParams::dec_, GRK_RANDOM_ACCESS_PLT, grk::grk_read(), and grk::DecodingParams::randomAccessFlags_.

Referenced by CodeStreamDecompress().

## read_poc()

bool grk::CodeStreamDecompress::read_poc | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a POC marker (Progression Order Change)

Parameters

  headerData | header data
  header_size | size of header data

References get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), GRK_J2K_MAXRLVLS, GRK_NUM_PROGRESSION_ORDERS, and grk::grk_read().

Referenced by CodeStreamDecompress().

## read_ppm()

bool grk::CodeStreamDecompress::read_ppm | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a PPM marker (Packed headers, main header)

Reads a PPM marker (Packed packet headers, main header)

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodeStream::cp_, grk::grk_read(), grk::CodingParams::ppm_marker, and grk::PPMMarker::read().

Referenced by CodeStreamDecompress().

## read_ppt()

bool grk::CodeStreamDecompress::read_ppt | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a PPT marker (Packed packet headers, tile-part header)

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodeStream::cp_, grk::CodeStream::currentProcessor(), grk::grk_calloc(), grk::GRK_ERROR(), grk::grk_malloc(), grk::grk_read(), and grk::grk_realloc().

Referenced by CodeStreamDecompress().

## read_qcc()

bool grk::CodeStreamDecompress::read_qcc | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a QCC marker (Quantization component)

Parameters

  headerData | header data
  header_size | size of header data

References getHeaderImage(), grk::GRK_ERROR(), grk::grk_read(), _grk_image::numcomps, and read_SQcd_SQcc().

Referenced by CodeStreamDecompress().

## read_qcd()

bool grk::CodeStreamDecompress::read_qcd | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a QCD marker (Quantization defaults)

Parameters

  headerData | header data
  header_size | size of header data

References get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), GRK_J2K_MAXBANDS, grk::grk_read(), _grk_image::numcomps, and read_SQcd_SQcc().

Referenced by CodeStreamDecompress().

## read_rgn()

bool grk::CodeStreamDecompress::read_rgn | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a RGN marker (Region Of Interest)

Parameters

  headerData | header data
  header_size | size of header data

References get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), and grk::grk_read().

Referenced by CodeStreamDecompress().

## read_short()

bool grk::CodeStreamDecompress::read_short | ( | uint16_t * | val | ) |

private

References grk::grk_read(), grk::BufferedStream::read(), and grk::CodeStream::stream_.

Referenced by readCurrentMarkerBody(), readHeaderProcedureImpl(), and readMarker().

## read_siz()

bool grk::CodeStreamDecompress::read_siz | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a SIZ marker (image and tile size)

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodeStream::cp_, grk::grk_read(), _grk_image::hasMultipleTiles, grk::CodeStream::headerImage_, grk::SIZMarker::read(), grk::CodingParams::t_grid_height, and grk::CodingParams::t_grid_width.

Referenced by CodeStreamDecompress().

## read_soc()

bool grk::CodeStreamDecompress::read_soc | ( |  | ) |

private

Reads a SOC marker (Start of Codestream)

References addMarker(), grk::CodeStream::codeStreamInfo, grk::DECOMPRESS_STATE_MH_SIZ, decompressorState_, grk::CodeStreamInfo::getMainHeaderStart(), grk::grk_read(), grk::J2K_MS_SOC, grk::MARKER_BYTES, grk::BufferedStream::read(), grk::CodeStreamInfo::setMainHeaderStart(), grk::DecompressorState::setState(), grk::CodeStream::stream_, and grk::BufferedStream::tell().

Referenced by readHeaderProcedureImpl().

## read_sot()

bool grk::CodeStreamDecompress::read_sot | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Read SOT (Start of tile part) marker.

Parameters

  headerData | header data.
  header_size | size of header data
  headerData | header data
  header_size | size of header data

References grk::grk_read(), and grk::SOTMarker::read().

Referenced by CodeStreamDecompress().

## read_SPCod_SPCoc()

bool grk::CodeStreamDecompress::read_SPCod_SPCoc | ( | uint16_t | compno,
|  | uint8_t * | headerData,
|  | uint16_t * | header_size
| ) |  |

private

Reads a SPCod or SPCoc element, i.e.

the coding style of a given component of a tile.

Parameters

  compno | component number
  headerData | the data contained in the COM box.
  header_size | the size of the data contained in the COM marker.

References grk::CodeStream::cp_, get_current_decode_tcp(), getHeaderImage(), GRK_CBLKSTY_HT, grk::GRK_ERROR(), GRK_J2K_MAX_DECOMP_LVLS, grk::grk_read(), J2K_CCP_CSTY_PRT, grk::CodingParams::pcap, and grk::SPCod_SPCoc_len.

Referenced by read_coc(), and read_cod().

## read_SQcd_SQcc()

bool grk::CodeStreamDecompress::read_SQcd_SQcc | ( | bool | fromQCC,
|  | uint16_t | compno,
|  | uint8_t * | headerData,
|  | uint16_t * | header_size
| ) |  |

private

Reads a SQcd or SQcc element, i.e.

the quantization values of a band in the QCD or QCC.

Parameters

  fromQCC | true if reading QCC, otherwise false (reading QCD)
  compno | the component number to output.
  headerData | the data buffer.
  header_size | pointer to the size of the data buffer, it is changed by the function.

References get_current_decode_tcp(), getHeaderImage(), grk::GRK_ERROR(), GRK_J2K_MAXBANDS, grk::grk_read(), grk::GRK_WARN(), isDecodingTilePartHeader(), J2K_CCP_QNTSTY_NOQNT, J2K_CCP_QNTSTY_SEQNT, and J2K_CCP_QNTSTY_SIQNT.

Referenced by read_qcc(), and read_qcd().

## read_tlm()

bool grk::CodeStreamDecompress::read_tlm | ( | uint8_t * | headerData,
|  | uint16_t | header_size
| ) |  |

private

Reads a TLM marker (Tile Length Marker)

Parameters

  headerData | header data
  header_size | size of header data

References grk::CodingParams::coding_params_, grk::CodeStream::cp_, grk::CodingParams::dec_, GRK_RANDOM_ACCESS_TLM, grk::grk_read(), grk::TileLengthMarkers::invalidate(), grk::DecodingParams::randomAccessFlags_, grk::TileLengthMarkers::read(), grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, and grk::CodingParams::tlm_markers.

Referenced by CodeStreamDecompress().

## read_unk()

bool grk::CodeStreamDecompress::read_unk | ( | void |  | ) |

private

References addMarker(), curr_marker_, get_marker_handler(), grk::GRK_ERROR(), grk::grk_read(), grk::MARKER_BYTES, readMarker(), grk::CodeStream::stream_, and grk::BufferedStream::tell().

Referenced by readHeaderProcedureImpl().

## readCurrentMarkerBody()

bool grk::CodeStreamDecompress::readCurrentMarkerBody | ( | uint16_t * | markerSize | ) |

private

References curr_marker_, grk::CodeStream::currentTileProcessor_, grk::DECOMPRESS_STATE_TPH, decompressorState_, get_marker_handler(), grk::DecompressorState::getState(), grk::GRK_ERROR(), grk::grk_read(), grk::MARKER_LENGTH_BYTES, process_marker(), read_short(), grk::marker_handler::states, and grk::TileProcessor::subtractMarkerSegmentLength().

Referenced by checkForIllegalTilePart(), and parseTileParts().

## readHeader()

bool grk::CodeStreamDecompress::readHeader | ( | grk_header_info * | header_info | ) |

virtual

Implements grk::ICodeStreamDecompress.

References _grk_header_info::cblk_sty, _grk_header_info::cblockh_init, _grk_header_info::cblockw_init, grk::CodingParams::comment, _grk_header_info::comment, grk::CodingParams::comment_len, _grk_header_info::comment_len, copy_default_tcp(), grk::GrkImage::copyHeader(), grk::CodeStream::cp_, _grk_header_info::csty, _grk_header_info::decompressFormat, decompressorState_, decompressValidation(), grk::DecompressorState::default_tcp_, grk::CodeStream::exec(), _grk_header_info::forceRGB, getCompositeImage(), grk::grk_read(), _grk_image::hasMultipleTiles, headerError_, grk::CodeStream::headerImage_, headerRead_, _grk_header_info::irreversible, grk::CodingParams::isBinaryComment, _grk_header_info::isBinaryComment, _grk_header_info::mct, grk::CodingParams::num_comments, _grk_header_info::num_comments, _grk_header_info::numlayers, _grk_header_info::numPrecision, _grk_header_info::numresolutions, _grk_header_info::prch_init, _grk_header_info::prcw_init, _grk_header_info::precision, grk::CodeStream::procedure_list_, readHeaderProcedure(), _grk_header_info::rsiz, _grk_header_info::singleTileDecompress, _grk_header_info::splitByComponent, grk::CodingParams::t_grid_height, _grk_header_info::t_grid_height, grk::CodingParams::t_grid_width, _grk_header_info::t_grid_width, grk::CodingParams::t_height, _grk_header_info::t_height, grk::CodingParams::t_width, _grk_header_info::t_width, grk::TileCodingParams::tccps, grk::CodingParams::tx0, _grk_header_info::tx0, grk::CodingParams::ty0, _grk_header_info::ty0, _grk_header_info::upsample, and grk::CodeStream::validation_list_.

Referenced by grk::FileFormatDecompress::readHeader().

## readHeaderProcedure()

bool grk::CodeStreamDecompress::readHeaderProcedure | ( | void |  | ) |

private

References grk::GRK_ERROR(), grk::grk_read(), and readHeaderProcedureImpl().

Referenced by readHeader().

## readHeaderProcedureImpl()

bool grk::CodeStreamDecompress::readHeaderProcedureImpl | ( | void |  | ) |

private

References addMarker(), grk::CodeStream::codeStreamInfo, grk::CodeStream::cp_, curr_marker_, grk::DECOMPRESS_STATE_MH_SOC, grk::DECOMPRESS_STATE_TPH_SOT, decompressorState_, get_marker_handler(), grk::DecompressorState::getState(), grk::GRK_ERROR(), grk::grk_read(), grk::marker_handler::id, grk::J2K_MS_COD, grk::J2K_MS_QCD, grk::J2K_MS_SIZ, grk::J2K_MS_SOT, grk::MARKER_BYTES, grk::MARKER_LENGTH_BYTES, grk::MARKER_PLUS_MARKER_LENGTH_BYTES, merge_ppm(), process_marker(), read_short(), read_soc(), read_unk(), readMarker(), grk::TileLengthMarkers::rewind(), grk::CodeStreamInfo::setMainHeaderEnd(), grk::DecompressorState::setState(), grk::marker_handler::states, grk::CodeStream::stream_, grk::BufferedStream::tell(), and grk::CodingParams::tlm_markers.

Referenced by readHeaderProcedure().

## readMarker() [1/2]

bool grk::CodeStreamDecompress::readMarker | ( | bool | suppressWarning | ) |

References curr_marker_, expectSOD_, grk::grk_read(), grk::GRK_WARN(), grk::J2K_MS_SOD, and read_short().

## readMarker() [2/2]

bool grk::CodeStreamDecompress::readMarker | ( | void |  | ) |

References readMarker().

Referenced by grk::DecompressorState::findNextSOT(), parseTileParts(), read_unk(), readHeaderProcedureImpl(), readMarker(), and readSOTorEOC().

## readSOTorEOC()

bool grk::CodeStreamDecompress::readSOTorEOC | ( | void |  | ) |

private

References curr_marker_, grk::DECOMPRESS_STATE_NO_EOC, decompressorState_, grk::grk_read(), grk::GRK_WARN(), grk::J2K_MS_EOC, grk::J2K_MS_SOT, grk::CodeStream::markerString(), readMarker(), and grk::DecompressorState::setState().

Referenced by decompressTile(), and parseTileParts().

## setDecompressRegion()

bool grk::CodeStreamDecompress::setDecompressRegion | ( | grk_rect_single | region | ) |

virtual

Implements grk::ICodeStreamDecompress.

References grk::CodingParams::coding_params_, grk::CodeStream::cp_, grk::CodingParams::dec_, grk::DECOMPRESS_STATE_TPH_SOT, decompressorState_, getCompositeImage(), grk::GRK_ERROR(), grk::GRK_INFO(), grk::grk_read(), grk::GRK_WARN(), grk::CodeStream::headerImage_, grk::DecodingParams::reduce_, grk::CodingParams::t_grid_height, grk::CodingParams::t_grid_width, grk::CodingParams::t_height, grk::CodingParams::t_width, grk::CodingParams::tx0, grk::CodingParams::ty0, grk::CodingParams::wholeTileDecompress_, and grk::grk_rect< T >::x0.

Referenced by grk::FileFormatDecompress::setDecompressRegion().

## setExpectSOD()

void grk::CodeStreamDecompress::setExpectSOD | ( |  | ) |

References expectSOD_.

Referenced by grk::SOTMarker::read().

## skipNonScheduledTLM()

bool grk::CodeStreamDecompress::skipNonScheduledTLM | ( | CodingParams * | cp | ) |

private

References grk::CodeStream::cp_, decompressorState_, hasTLM(), grk::TileLengthMarkers::seek(), grk::CodeStream::stream_, grk::DecompressorState::tilesToDecompress_, and grk::CodingParams::tlm_markers.

Referenced by decompressTile(), and parseTileParts().

## Member Data Documentation

## curr_marker_

uint16_t grk::CodeStreamDecompress::curr_marker_

private

Referenced by decompressTile(), decompressTiles(), getCurrentMarker(), parseTileParts(), read_unk(), readCurrentMarkerBody(), readHeaderProcedureImpl(), readMarker(), and readSOTorEOC().

## decompressorState_

DecompressorState grk::CodeStreamDecompress::decompressorState_

private

Referenced by CodeStreamDecompress(), copy_default_tcp(), decompressTile(), decompressTile(), decompressTiles(), decompressValidation(), endOfCodeStream(), findNextSOT(), get_current_decode_tcp(), getDecompressorState(), isDecodingTilePartHeader(), nextTLM(), parseTileParts(), read_soc(), readCurrentMarkerBody(), readHeader(), readHeaderProcedureImpl(), readSOTorEOC(), setDecompressRegion(), skipNonScheduledTLM(), and ~CodeStreamDecompress().

## expectSOD_

bool grk::CodeStreamDecompress::expectSOD_

private

Referenced by parseTileParts(), readMarker(), and setExpectSOD().

## grkRegisterReclaimCallback_

grk_io_register_reclaim_callback grk::CodeStreamDecompress::grkRegisterReclaimCallback_

private

Referenced by decompressTile(), decompressTiles(), and init().

## headerError_

bool grk::CodeStreamDecompress::headerError_

private

Referenced by decompressTile(), decompressTiles(), needsHeaderRead(), and readHeader().

## headerRead_

bool grk::CodeStreamDecompress::headerRead_

private

Referenced by needsHeaderRead(), and readHeader().

## ioBufferCallback

grk_io_pixels_callback grk::CodeStreamDecompress::ioBufferCallback

private

Referenced by decompressTile(), decompressTiles(), and init().

## ioUserData

void* grk::CodeStreamDecompress::ioUserData

private

Referenced by decompressTile(), decompressTiles(), and init().

## marker_map

std::map<uint16_t, marker_handler*> grk::CodeStreamDecompress::marker_map

private

Referenced by CodeStreamDecompress(), get_marker_handler(), and ~CodeStreamDecompress().

## marker_scratch_

uint8_t* grk::CodeStreamDecompress::marker_scratch_

private

Referenced by process_marker(), and ~CodeStreamDecompress().

## marker_scratch_size_

uint16_t grk::CodeStreamDecompress::marker_scratch_size_

private

Referenced by process_marker().

## outputImage_

GrkImage* grk::CodeStreamDecompress::outputImage_

private

Referenced by createOutputImage(), decompressExec(), decompressTile(), decompressTile(), decompressTiles(), and ~CodeStreamDecompress().

## stripCache_

StripCache grk::CodeStreamDecompress::stripCache_

private

Referenced by allocateProcessor(), decompressTile(), and decompressTiles().

## tileCache_

TileCache* grk::CodeStreamDecompress::tileCache_

private

Referenced by allocateProcessor(), decompressTile(), decompressTile(), decompressTiles(), getAllImages(), getCompositeImage(), getImage(), init(), and ~CodeStreamDecompress().

The documentation for this class was generated from the following files:

- CodeStreamDecompress.h
- CodeStreamDecompress.cpp
- CodeStreamDecompress_Markers.cpp